.586
.model flat,stdcall
option casemap:none

include DXtut - lesson 5.Inc

.code

start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL starting_point:DWORD
	
	invoke RtlZeroMemory,addr wc,sizeof wc
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	;mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_EX_TOPMOST OR WS_POPUP,0,\
           0,SCREEN_WIDTH,SCREEN_HEIGHT,NULL,NULL,\
           hInst,NULL
	mov   hWnd,eax
	
	invoke ShowWindow,hWnd,CmdShow
	
	invoke InitD3D
	
	invoke GetTickCount
	mov starting_point,eax
	.while (TRUE)
	invoke PeekMessage,addr msg,NULL,0,0,PM_REMOVE
		.if (eax)
			.if msg.message==WM_QUIT
				.break
			.endif
			invoke TranslateMessage,addr msg
			invoke DispatchMessage,addr msg
		invoke Render_Frame
		invoke GetAsyncKeyState,VK_ESCAPE
		.if (eax)
			invoke PostMessage,hWnd,WM_DESTROY,0,0
		.endif
		.endif
		@@:
		invoke GetTickCount
		sub eax,starting_point
		cmp eax,25
		jb @B
		
    .endw
	
	invoke CleanD3D
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSE
		invoke DefWindowProc,hWin,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp

InitD3D proc  ;this function initializes and prepares Direct3D for use
LOCAL d3dpp:D3DPRESENT_PARAMETERS ;create a struct to hold various device information

    ;create the Direct3D interface
    invoke Direct3DCreate9,D3D_SDK_VERSION
    mov d3d,eax
    
    invoke RtlZeroMemory,addr d3dpp,sizeof d3dpp ;clear out the struct for use
    mov d3dpp.Windowed,FALSE ;program windowed, not fullscreen
    mov d3dpp.SwapEffect,D3DSWAPEFFECT_DISCARD ;discard old frames
    ;set the window to be used by Direct3D
    push hWnd
    pop d3dpp.hDeviceWindow
    mov d3dpp.BackBufferFormat,D3DFMT_X8R8G8B8 ;set the back buffer format to 32-bit
    mov d3dpp.BackBufferWidth,SCREEN_WIDTH ;set the width of the buffer
    mov d3dpp.BackBufferHeight,SCREEN_HEIGHT ;set the height of the buffer
    
    ;create a device class using this information and information from the d3dpp stuct
    cinvoke d3d,CreateDevice,D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,hWnd,D3DCREATE_SOFTWARE_VERTEXPROCESSING,addr d3dpp,addr d3ddev
    
    invoke Init_Graphics
    
    ;turn off the 3D lighting
    cinvoke d3ddev,SetRenderState,D3DRS_LIGHTING,FALSE
    
   	ret
InitD3D endp

Render_Frame proc ;this is the function used to render a single frame
LOCAL matRotateY:D3DXMATRIX ;a matrix to store the rotation information
LOCAL matView:D3DXMATRIX ;the view transform matrix
LOCAL matProjection:D3DXMATRIX ;the projection transform matrix
	
	cinvoke d3ddev,Clear,0,NULL,D3DCLEAR_TARGET,($D3DCOLOR_XRGB(0,0,0)),var1,0
	cinvoke d3ddev,BeginScene ;begins the 3D scene
	
	;select which vertex format we are using
	cinvoke d3ddev,SetFVF,CUSTOMFVF
	
	;SET UP THE PIPELINE
	
	fld index0
	fadd index5
	fst index0
	
	;build a matrix to rotate the model based on the increasing float value
	invoke D3DXMatrixRotationY,addr matRotateY,index0
	
	;tell Direct3D about our matrix
	cinvoke d3ddev,SetTransform,D3DTS_WORLD,addr matRotateY
	
	invoke D3DXMatrixLookAtLH,addr matView,addr argm1,addr argm2,addr argm3
	
	;set the view transform to matView
    cinvoke d3ddev,SetTransform,D3DTS_VIEW,addr matView	                                       
	                                                  
    invoke D3DXMatrixPerspectiveFovLH,addr matProjection,var3,AR,var1,var2    	
    
    ;set the projection
    cinvoke d3ddev,SetTransform,D3DTS_PROJECTION,addr matProjection                                                  
	
	;select the vertex buffer to display
	cinvoke d3ddev,SetStreamSource,0,t_buffer,0,sizeof CUSTOMVERTEX
	
	;copy the vertex buffer to the back buffer
	cinvoke d3ddev,DrawPrimitive,D3DPT_TRIANGLELIST,0,1
	
	
	cinvoke d3ddev,EndScene ;ends the 3D scene
    cinvoke d3ddev,Present,NULL,NULL,NULL,NULL ;displays the created frame
	
	ret
Render_Frame endp

CleanD3D proc ;this is the function that cleans up Direct3D and COM
    
	cinvoke d3ddev,Release ;close and release the 3D device
	cinvoke d3d,Release ;close and release Direct3D
	
	ret
CleanD3D endp

Init_Graphics proc ;this is the function that puts the 3D models into video RAM
LOCAL pvoid:DWORD 
    
    ;create a vertex buffer interface called t_buffer
    cinvoke d3ddev,CreateVertexBuffer,(3*sizeof(CUSTOMVERTEX)),0,CUSTOMFVF,D3DPOOL_MANAGED,addr t_buffer,NULL
	
	;lock t_buffer and load the vertices into it
	cinvoke t_buffer,_Lock,0,0,addr pvoid,0
	invoke RtlMoveMemory,pvoid,addr t_vert,sizeof t_vert
	cinvoke t_buffer,Unlock
	
	ret
Init_Graphics endp


end start
