include windows.inc

include user32.inc
include kernel32.inc
include shell32.inc
include comctl32.inc
include comdlg32.inc
include masm32.inc
include winmm.inc

include C:\masm32\macros\macros.asm

includelib user32.lib
includelib kernel32.lib
includelib shell32.lib
includelib comctl32.lib
includelib comdlg32.lib
includelib masm32.lib
includelib winmm.lib

include d3d9_.inc
include d3dx9math_.inc
include d3d9caps_.inc
include d3d9types_.inc
include d3dx9core_.inc

includelib d3d9.lib
includelib d3dx9.lib

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
WndProc proto :DWORD,:DWORD,:DWORD,:DWORD

InitD3D             PROTO ;sets up and initializes Direct3D
Render_Frame        PROTO ;renders a single frame
CleanD3D            PROTO ;closes Direct3D and releases memory
Init_Graphics       PROTO ;3D declarations

;from d3d9.h
Direct3DCreate9     PROTO :DWORD

.const
;Ariel ds macros
STDMETHOD	MACRO	name, argl :VARARG
LOCAL @tmp_a
LOCAL @tmp_b

@tmp_a	TYPEDEF PROTO argl
@tmp_b	TYPEDEF PTR @tmp_a
name		@tmp_b		?
ENDM
CINVOKE	MACRO	Nombre, func, arglist :VARARG ; No usar edx como argumento
	FOR var, <arglist>
		IFIDNI <"&var">, <"edx">
			.ERR <No se permite usar como argumento EDX> 
		ENDIF
	ENDM 
	mov			edx , Nombre
	mov			edx , [edx]
	ASSUME EDX: PTR _Interface_&Nombre&
	IFB <arglist>
		INVOKE [edx].func, Nombre
	ELSE
		INVOKE [edx].func, Nombre, arglist
	ENDIF
	ASSUME EDX:NOTHING
ENDM
COM MACRO Nombre, Interface
	Nombre dd 0
	_Interface_&Nombre& equ <&Interface&>
ENDM
LCOM MACRO Nombre, Interface
	%LOCAL &Nombre&:DWORD
	_Interface_&Nombre& equ <&Interface&>
ENDM

.data?

hInstance HINSTANCE ?
CommandLine LPSTR ?
hWnd HWND ?

CUSTOMVERTEX struct
	x     real4 ? 
	y     real4 ?
	z     real4 ?
	color dword ? 
CUSTOMVERTEX ends

.data
ClassName db "MainWinClass",0
AppName  db "Main Window",0

SCREEN_WIDTH  equ 640
SCREEN_HEIGHT equ 480

D3D_SDK_VERSION	    equ	32
cinvoke             equ CINVOKE

CUSTOMFVF equ D3DFVF_XYZ OR D3DFVF_DIFFUSE

sIID_IDirect3D9  TEXTEQU  <{081BDCBCAH,064D4H,0426DH,{0AEH,08DH,0ADH,01H,047H,0F4H,027H,05CH}}>
IID_IDirect3D9 GUID <081BDCBCAH,064D4H,0426DH,<0AEH,08DH,0ADH,01H,047H,0F4H,027H,05CH>>

sIID_IDirect3DDevice9  TEXTEQU  <{0D0223B96H,0BF7AH,043FDH,{092H,0BDH,0A4H,03BH,0DH,082H,0B9H,0EBH}}>
IID_IDirect3DDevice9 GUID <0D0223B96H,0BF7AH,043FDH,<092H,0BDH,0A4H,03BH,0DH,082H,0B9H,0EBH>>

sIID_IDirect3DVertexBuffer9  TEXTEQU  <{0B64BB1B5H,0FD70H,04DF6H,{0BFH,091H,019H,0D0H,0A1H,024H,055H,0E3H}}>
IID_IDirect3DVertexBuffer9 GUID <0B64BB1B5H,0FD70H,04DF6H,<0BFH,091H,019H,0D0H,0A1H,024H,055H,0E3H>>

COM d3d,IDirect3D9 ;the pointer to our direct3D interface
COM d3ddev,IDirect3DDevice9 ;the pointer to the device interface
COM t_buffer,IDirect3DVertexBuffer9 ;the pointer to the vertex buffer

var1   real4   1.0
var2   real4 100.0
var3   real4 0.7853981635
var4   real4 150.0

AR     real4 1.333

argm1 D3DXVECTOR3 {0.0,0.0,10.0} ;the camera position
argm2 D3DXVECTOR3 {0.0,0.0,0.0} ; the look-at position
argm3 D3DXVECTOR3 {0.0,1.0,0.0} ;the up direction

t_vert CUSTOMVERTEX { 2.5, -3.0, 0.0, ($D3DCOLOR_XRGB(0, 0, 255)) },
                    { 0.0,  3.0, 0.0, ($D3DCOLOR_XRGB(0, 255, 0)) },
                    {-2.5, -3.0, 0.0, ($D3DCOLOR_XRGB(255, 0, 0)) }
                    
index5  real4 0.05
index0  real4 0.00            



                    

           




